#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

#define NSYNC (16)
#define NBYSEC ((NSYNC*10)/8+16+18+342)

#define MAXFILE (2<<20)
unsigned char mbuf[MAXFILE];

#define MAXTRK (160)

int trkoffset[MAXTRK], trknbits[MAXTRK];

unsigned char *trkp;
int nbits,bitix;

int getbit()
{
	int d;
	d=(trkp[bitix>>3]>>(7-(bitix&7)) )&1;
	if (++bitix>=nbits) {printf("."); bitix=0; }
	return d;
}

int getbyte()
{
	int i,d;
	d=0;
	for (i=0;i<8;i++) {d<<=1; d+=getbit();}
	return d;
}

int find_address_mark()
{
	int i,d;
	d=i;
	i=nbits+100;
	do {
		i--;
		d<<=1;
		d+=getbit();
	} while ((d&0xFFFFFF)!=0xD5AA96 && i);
	return (i==0);
}

main(int argc, char **argv)
{
	int i,j,k,n,trk,sec,v,t,s,c;
	int bix[16];
	unsigned char *p,buf[1024];
	FILE *fp;
	
	if (argc<3) {
		printf(
			"Usage: %s <input.woz> <output.raw>\n"
			,argv[0],argv[0]);
		exit(1);
	}
	
	if ((fp=fopen(argv[1],"rb"))==NULL) exit(1);
	
	n=fread(mbuf,1,MAXFILE,fp);
	fclose(fp);
	
	if (n==6656*35) {
		printf("RAW image file, dewrapping\n");
		for (i=0;i<35;i++) {
			trkoffset[i]=i*6656;
			trknbits[i]=(6656-264)*8;
		}
	}else{
		if (mbuf[0]!='W' || mbuf[1]!='O' || mbuf[2]!='Z') {
			printf("Not WOZ file\n");
			exit(1);
		}
		// Read track info depending on version
		if (mbuf[3]=='1') {
			printf("WOZ file v%c\n",mbuf[3]);
			k=256;
			for (i=0;i<35;i++) {
				trkoffset[i]=k;
				j=mbuf[k+6648]+mbuf[k+6649]*256;
				trknbits[i]=j;
				//printf("trk %2d: %d bits\n",i,j);
				k+=6656;
			}	
		} else if (mbuf[3]=='2') {
			printf("WOZ file v%c\n",mbuf[3]);
			for (i=0;i<35;i++) {
				k=mbuf[256+i*8]+mbuf[256+i*8+1]*256;
				j=mbuf[256+i*8+4]+mbuf[256+i*8+5]*256+mbuf[256+i*8+6]*65536;
				trkoffset[i]=k*512;
				trknbits[i]=j;
				//printf("trk %2d: %4d %d bits\n",i,k,j);
			}
		} else {printf("Invalid WOZ version (%c)\n",mbuf[3]); exit(1);}
	}

	if ((fp=fopen(argv[2],"wb"))==NULL) exit(1);

	for (trk=0;trk<35;trk++) {
		trkp=&mbuf[trkoffset[trk]];
		nbits=trknbits[trk];
		bitix=0;
		printf("Trk %02X (%5d bits)  ",trk,nbits); fflush (stdout);
		for (i=0;i<16;i++) bix[i]=0;
		for (sec=0;sec<16;sec++) {
			if (find_address_mark()) {printf("T "); continue;}
			k=bitix-(24+NSYNC*10); if (k<0) k+=nbits;
			v=(getbyte()<<1)+1;
			v&=getbyte();
			t=(getbyte()<<1)+1;
			t&=getbyte();
			s=(getbyte()<<1)+1;
			s&=getbyte();
			c=(getbyte()<<1)+1;
			c&=getbyte();
			i=(v^t^s^c);
			if (i) printf("# ");
			else {
				printf("%X ",s);
				bix[s]=k;
			}
			fflush (stdout);
		}
		for (sec=0;sec<16;sec++) {
			bitix=bix[sec];
			for (i=0;i<NBYSEC;i++) buf[i]=getbyte();
			fwrite(buf,1,NBYSEC,fp);
		}
		// pad
		k=6656-16*NBYSEC;
		printf(" Pad\n");
		for (i=0;i<k;i++) buf[i]=0;
		fwrite(buf,1,k,fp);
		
	}
	
	fclose(fp);
	
}
